{application,gen_rpc,
             [{description,"A scalable RPC library for Erlang-VM based languages"},
              {vsn,"3.3.1"},
              {mod,{gen_rpc_app,[]}},
              {registered,[gen_rpc_dispatcher]},
              {maintainers,["Panagiotis PJ Papadomitsos"]},
              {licenses,["Apache 2.0"]},
              {links,[{"Github","https://github.com/priestjim/gen_rpc"}]},
              {files,["LICENSE","README.md","CHANGELOG.md","include",
                      "package.exs","rebar.config","src"]},
              {applications,[kernel,stdlib,crypto,asn1,public_key,ssl]},
              {env,[{tcp_server_port,5369},
                    {tcp_client_port,5369},
                    {ssl_server_port,false},
                    {ssl_server_options,[]},
                    {ssl_client_port,5370},
                    {ssl_client_options,[]},
                    {default_client_driver,tcp},
                    {client_config_per_node,{internal,#{}}},
                    {rpc_module_control,disabled},
                    {rpc_module_list,[]},
                    {connect_timeout,5000},
                    {send_timeout,5000},
                    {authentication_timeout,5000},
                    {call_receive_timeout,15000},
                    {sbcast_receive_timeout,15000},
                    {client_inactivity_timeout,infinity},
                    {server_inactivity_timeout,infinity},
                    {async_call_inactivity_timeout,infinity},
                    {socket_keepalive_idle,5},
                    {socket_keepalive_interval,5},
                    {socket_keepalive_count,2},
                    {socket_ip,{0,0,0,0}},
                    {ipv6_only,false}]},
              {modules,[gen_rpc,gen_rpc_acceptor,gen_rpc_acceptor_sup,
                        gen_rpc_app,gen_rpc_auth,gen_rpc_client,
                        gen_rpc_client_config,gen_rpc_client_sup,
                        gen_rpc_dispatcher,gen_rpc_driver,gen_rpc_driver_ssl,
                        gen_rpc_driver_tcp,gen_rpc_helper,gen_rpc_keepalive,
                        gen_rpc_registry,gen_rpc_server,gen_rpc_sup]}]}.
